/* Very simple program to run as node job for Pegasus/DAGMan tutorial. */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>

int
main( int argc, char **argv )
{
	int argNum;
	int sleepTime = 60;
	int fail = 0;
	char *usage = "nodejob ... [-sleep <seconds>] [-fail] ...";

	// Check for fail, sleep time arguments.
	argNum = 0;
	while ( argNum < argc ) {
		if ( !strcmp( argv[argNum], "-sleep" ) ) {
			argNum++;
			if ( argNum < argc ) {
				sleepTime = atoi( argv[argNum] );
			} else {
				fprintf( stderr, "Error: -sleep argument must have value\n" );
				fprintf( stderr, "Usage: %s\n", usage );
				exit( 1 );
			}
		}

		if ( !strcmp( argv[argNum], "-fail" ) ) {
			fail = 1;
		}

		argNum++;
	}

	printf( "Sleeping for %d seconds...\n", sleepTime );
	sleep( sleepTime );

	// Print all arguments.
	printf( "Arguments:\n" );
	for ( argNum = 0; argNum < argc; argNum++ ) {
		printf("  %s\n", argv[argNum] );
	}

	if ( fail ) {
		fprintf( stderr, "Node job failed because of -fail argument\n" );
		exit( 1 );
	} else {
		exit( 0 );
	}
}
